#pragma once

#include "../types.h"

struct AcpiRSDP;
struct AcpiXSDT;

/**
 * ACPI Root System Description Pointer
 */
struct [[gnu::packed]] AcpiRSDP {
	char             Signature[8];
	u8               Checksum;
	char             OEM[6];
	u8               Revision;
	[[gnu::deprecated]] // we dont care :>
	u32              RSDTAddress;
	u32              Length;
	struct AcpiXSDT* XSDTAddress;
	u8               ExtendedChecksum;
	u8               Reserved[3];
};
